<?
/*
+---------------------------------------------------------------+
|autoapprove
|v0.3 2007/11/05
|
|©nick gordon 2007
|http://www.violemment.com
|ngordon779@violemment.com
|
|automatically approves news and uploads.
|
|Released under the terms and conditions of the
|GNU General Public License (http://gnu.org).
+---------------------------------------------------------------+
*/
global $e_event;
$e_event->register("subnews","autoapprove_subnews");
$e_event->register("fileupload","autoapprove_fileupload");

/**
* autoapprove_subnews 2007/09/30 v1.0
* @purpose:		callback function for 'subnews' event hook when a
*				new news item is submitted via submitnews.php
* @params:		array	$data	(req)	array of submitted news
*										data from the event sink
* @returns:		none
* @notes:
* 	May or may not be a problem, this function relies on using 
* the SQL function 'LAST_INSERT_ID()' to obtain the submitnews_id
* of the news item just submitted. This is *not* threadsafe, but I
* think it would require a very, very high volume of submitted
* news items in order for this to become a problem.
*/
function autoapprove_subnews($data) {
	global $sql, $ns;
	require_once(e_HANDLER."news_class.php");
	$ix = new news;
	//TODO: Check to see if user's access level is high enough to have news automatically approved
	if($sql->db_Select('submitnews','*','submitnews_id = LAST_INSERT_ID()',TRUE)){
		list($id, $submitnews_name, $submitnews_email, $news['news_title'], $news['cat_id'], $news['data'], $news['news_datestamp'], $submitnews_ip, $submitnews_auth, $submitnews_file) = $sql->db_Fetch();
		//TODO: Define whether or not to include images in automatic posting
		if (e_WYSIWYG)
			$news['data'] .= ($submitnews_file)? "<br /><br /><img src='{e_IMAGE}newspost_images/".$submitnews_file."' style='float:right; margin-left:5px;margin-right:5px;margin-top:5px;margin-bottom:5px; border:1px solid' />":	"";
		else
			$news['data'] .= ($submitnews_file)?"\n\n[img]{e_IMAGE}newspost_images/".$submitnews_file."[/img]": "";
		$news['cat_id'] = $submitnews_category;
		//TODO: Set default class by configuration setting
		$news['news_class'] = 0;
		$news['news_start'] = 0;
		$news['news_end'] = 0;
		if (!$news['cat_id'])
			$news['cat_id'] = 1;
		$sql->db_Update("submitnews", "submitnews_auth='1' WHERE submitnews_id ='".$id."' ");
		$ix->submit_item($news);
		//TODO: localization
		$ns -> tablerender('AutoApprove','AutoApprove has automatically approved your news item and it is now available in the news posting area.');
	}
}

/**
* autoapprove_fileupload 2007/11/05 v1.2
* @purpose:		callback function for 'fileupload' event hook,
* 				called when a new file is uploaded via the
* 				public upload interface. File is automatically
* 				moved to downloads section and file is removed
* 				from uploads.
* @params:		array	$data	{req}	array of data about
*										download from the event
* 										sink
* @returns:		none
* @notes:
* 	As with the above function, this function relies on using 
* the SQL function 'LAST_INSERT_ID()' to obtain the submitnews_id
* of the news item just submitted. This is *not* threadsafe, but I
* think it would require a very, very high volume of submitted
* upload items in order for this to become a problem.
*/
function autoapprove_fileupload($data) {
	global $sql, $DOWNLOADS_DIRECTORY, $e_event, $tp, $ns;
	//TODO: Check to see if user's access level is high enough to have uploads automatically approved
	if ($sql->db_Select("upload", "*", "upload_id=LAST_INSERT_ID() ")) {
		$row = $sql->db_Fetch();

		$upload_id = $row['upload_id'];
		$download['category']  = $row['upload_category'];
		$download['name']  = $row['upload_name'].($row['upload_version'] ? " v" . $row['upload_version'] : "");
		$download['url']  = $row['upload_file'];
		$download['author_email']  = $row['upload_email'];
		$download['author_website']  = $row['upload_website'];
		$download['description']  = $row['upload_description'];
		$download['image']  = $row['upload_ss'];
		$download['filesize']  = $row['upload_filesize'];
		$image_array[] = array("path" => "", "fname" => $row['upload_ss']);
		$download['author']  = substr($row['upload_poster'], (strpos($row['upload_poster'], ".")+1));
		if(!$download['datestamp'] ){
			$download['datestamp']  = time();
		}
		
		$durl = $download['url'];
		$filesize = $download['filesize'];
		//TODO: move files and images by configuration setting
		if($download['image']) {
			$oldname = e_FILE."public/".$download['image'];
			$newname = e_FILE."downloadimages/".$download['image'];
			if(!move_file($oldname,$newname)) {
				//return;
			}
		}
		//if($_POST['move_file'] && $_POST['download_url']) {
		$oldname = e_FILE."public/".$durl;
		$newname = $durl;
		if(!move_file($oldname,$newname)) {
			//return;
		} else {
		$durl = str_replace(e_DOWNLOAD,"",$newname);
		}
		//}
	
		$download['description'] = $tp->toDB($download['description']);
		$download['name'] = $tp->toDB($download['name']);
		$download['author'] = $tp->toDB($download['author']);
		$download['active'] = 1;
		//TODO: default class by configuration settings
		$download['class'] = 0;
		//TODO: default mirror? by config maybe...
		$download['mirror_type'] = 0;
		$download['visible'] = 0;
	
		if (preg_match("#(.*?)/(.*?)/(.*?) (.*?):(.*?):(.*?)$#", $download['datestamp'], $matches)){
			$download['datestamp'] = mktime($matches[4], $matches[5], $matches[6], $matches[2], $matches[1], $matches[3]);
		}else{
		   $download['datestamp'] = time();
		}
	
		if ($download_id = $sql->db_Insert("download", "0, '".$download['name']."', '".$durl."', '".$download['author']."', '".$download['author_email']."', '".$download['author_website']."', '".$download['description']."', '".$filesize."', '0', '".intval($download['category'])."', '".intval($download['active'])."', '".intval($download['datestamp'])."', '".$download['thumb']."', '".$download['image']."', '".intval($download['comment'])."', '{$download['class']}', '$mirrorStr', '".intval($download['mirror_type'])."', '".$download['visible']."' ")) {
			$dlinfo = array("download_id" => $download_id, "download_name" => $download['name'], "download_url" => $durl, "download_author" => $download['author'], "download_author_email" => $download['author_email'], "download_author_website" => $download['author_website'], "download_description" => $download['description'], "download_filesize" => $filesize, "download_category" => $download['category'], "download_active" => $download['active'], "download_datestamp" => $time, "download_thumb" => $download['thumb'], "download_image" => $download['image'], "download_comment" => $download['comment'] );
			$e_event->trigger("dlpost", $dlinfo);
			//TODO: remove uploads by configuration setting
			//if ($_POST['remove_upload']) {
				$sql->db_Update("upload", "upload_active='1' WHERE upload_id='".$upload_id."'");
			//}
			//TODO: localization
			$ns -> tablerender('AutoApprove','AutoApprove has automatically approved your upload and moved it to the uploads section.<br /><br /><a href="'.SITEURL.'/download.php?view.'.$download_id.'">View Download</a>');
		} else {
			//TODO: localization
			$ns -> tablerender(LAN_ERROR.': AutoApprove','AutoApprove encountered an error in automatically approving your upload.');
		}
	}
}

/**
* move_file
* @notes:
* 	removed directly from e107_admin/download.php with minor changes
*/
function move_file($oldname,$newname)
{
	global $ns;
	@include_once(e_LANGUAGEDIR."English/admin/lan_download.php");
	@include_once(e_LANGUAGEDIR.e_LANGUAGE."/admin/lan_download.php");
	if(file_exists($newname))
	{
		return TRUE;
	}

	if(!file_exists($oldname) || is_dir($oldname))
	{
		$ns -> tablerender(LAN_ERROR,DOWLAN_68 . " : ".$oldname);
		return FALSE;
	}

	$directory = dirname($newname);
	if(is_writable($directory))
	{
		if(!rename($oldname,$newname))
		{
			$ns -> tablerender(LAN_ERROR,DOWLAN_152." ".$oldname ." -> ".$newname);
			return FALSE;
		}
		else
		{
			return TRUE;
		}
	}
	else
	{
		$ns -> tablerender(LAN_ERROR,$directory ." ".LAN_NOTWRITABLE);
		return FALSE;
	}
}
?>